﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace 五子棋
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        //初始化225个按钮
        Button[,] btn = new Button[15, 15];
        //与按钮对应的图片，根据玩家的操作会有所变化
        PictureBox[,] pcb = new PictureBox[15, 15];
        //血量显示图片
        PictureBox[] pblood = new PictureBox[4];
        //用于存储棋盘信息的二维数组，9表示这个位置是地雷，其他数字表示该位置附近的雷数
        static int[,] QiPan = new int[15, 15];
        //用于存放随即得到的地雷位置
        static int[] DiLei = new int[30];
        //血量标识
        static int chance;

        //窗口加载时完成以下内容:
        //1、从0-225之间（不包括225）随即生成30个不同的数字，用于产生地雷的位置
        //2、根据第一步计算出QiPan数组所有的数字
        //3、给所有位置放置按钮,并且根据QiPan数组的数据，给所有位置放置一个初始图片，Visible属性为false
        //4、初始化玩家的4点血量
        private void Form1_Load(object sender, EventArgs e)
        {
            #region//生成数字，方法ran，并得到地雷的位置，将对应位置的QiPan数组数字改为9
            ran();
            chance = 0;
            for (int i = 0; i < DiLei.Length; i++)
            {
                int temp = DiLei[i];
                QiPan[temp / 15, temp % 15] = 9;
            }
            #endregion

            #region//根据地雷的位置，计算出QiPan数组中的其他数字
            //前两层循环用于遍历棋盘所有位置
            for (int i = 0; i < 15; i++)
            {
                for (int j = 0; j < 15; j++)
                {
                    //如果遍历到的位置值为9，说明此处为地雷（上一步的设置）
                    if (QiPan[i, j] == 9)
                        continue;
                    //不是地雷的点，就要查找它附近8个格子的地雷数目(该点位于边缘，则附近点不到8个)，每次检测到一个地雷，该点数字+1
                    //不过由于自己本身必然不是地雷，所以检测自己也不影响计算
                    else
                    {
                        for (int m = i - 1; m < i + 2; m++)
                        {
                            for (int n = j - 1; n < j + 2; n++)
                            {
                                //越界检测
                                if (m == -1 || m == 15 || n == -1 || n == 15)
                                    continue;
                                else
                                {
                                    if (QiPan[m, n] == 9)
                                        QiPan[i, j]++;
                                }
                            }
                        }
                    }
                }
            }
            #endregion

            #region//给所有位置放置按钮,并且根据QiPan数组的数据，给所有位置放置一个初始图片，Visible属性为false

            for (int i = 0; i < 15; i++)
            {

                for (int j = 0; j < 15; j++)
                {
                    #region//放置按钮部分
                    btn[i, j] = new Button();
                    btn[i, j].Name = "btn[i]";
                    //这里为了让i和j有确切的几何意义（i表示行，j表示列），i与纵坐标相关，j与横坐标相关
                    btn[i, j].Location = new System.Drawing.Point(25 + j * 30, 80 + i * 30);
                    btn[i, j].Size = new System.Drawing.Size(32, 32);
                    btn[i, j].Text = "";
                    btn[i, j].UseVisualStyleBackColor = true;
                    btn[i, j].TabStop = false;
                    btn[i, j].Click += new System.EventHandler(btn_Click);
                    this.Controls.Add(btn[i, j]);
                    #endregion

                    #region//放置图片部分
                    pcb[i, j] = new PictureBox();
                    pcb[i, j].Location = new System.Drawing.Point(25 + j * 30, 80 + i * 30);
                    pcb[i, j].Size = new System.Drawing.Size(30, 30);
                    pcb[i, j].SizeMode = System.Windows.Forms.PictureBoxSizeMode.StretchImage;
                    pcb[i, j].BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
                    switch (QiPan[i, j])
                    {
                        case 0:
                            pcb[i, j].Image = Image.FromFile("0.jpg");
                            break;
                        case 1:
                            pcb[i, j].Image = Image.FromFile("1.jpg");
                            break;
                        case 2:
                            pcb[i, j].Image = Image.FromFile("2.jpg");
                            break;
                        case 3:
                            pcb[i, j].Image = Image.FromFile("3.jpg");
                            break;
                        case 4:
                            pcb[i, j].Image = Image.FromFile("4.jpg");
                            break;
                        case 5:
                            pcb[i, j].Image = Image.FromFile("5.jpg");
                            break;
                        case 6:
                            pcb[i, j].Image = Image.FromFile("6.jpg");
                            break;
                        case 7:
                            pcb[i, j].Image = Image.FromFile("7.jpg");
                            break;
                        case 8:
                            pcb[i, j].Image = Image.FromFile("8.jpg");
                            break;
                        default:
                            pcb[i, j].Image = Image.FromFile("雷.jpg");
                            break;
                    }
                    pcb[i, j].Visible = false;
                    this.Controls.Add(pcb[i, j]);
                    #endregion
                }
            }
            #endregion

            #region//初始化玩家的4点血量
            for (int i = 0; i < 4; i++)
            {
                pblood[i] = new PictureBox();
                pblood[i].Location = new System.Drawing.Point(200 + i * 70, 15);
                pblood[i].Size = new System.Drawing.Size(50, 50);
                pblood[i].SizeMode = System.Windows.Forms.PictureBoxSizeMode.StretchImage;
                pblood[i].BorderStyle = System.Windows.Forms.BorderStyle.None;
                pblood[i].Visible = true;
                pblood[i].Image = Image.FromFile("blood.jpg");
                this.Controls.Add(pblood[i]);
            }
            #endregion
        }

        #region//按钮点击事件的处理
        private void btn_Click(object sender, EventArgs e)
        {
            #region//根据被点击按钮的位置坐标p，推算出被点击按钮的索引i，j
            int i, j;
            Button btn1 = sender as Button;
            Point p = new Point();
            p = btn1.Location;
            i = (p.Y - 80) / 30;
            j = (p.X - 25) / 30;
            #endregion

            #region//玩家踩雷的处理
            if (QiPan[i, j] == 9)
            {
                #region//玩家没阵亡的处理
                //首先将被点击的按钮隐藏，然后为了醒目，
                //更换“踩雷.jpg”图片代替原来初始化的图片，并显示出这张图片
                btn[i, j].Visible = false;
                pcb[i, j].Image = Image.FromFile("踩雷.jpg");
                pcb[i, j].Visible = true;
                //每次踩雷隐藏一张血量图片，chance值+1，若玩家没阵亡，提示剩余血量
                if (chance != 3)
                {
                    pblood[chance].Visible = false;
                    MessageBox.Show("这个是雷，您还有" + (3 - chance).ToString() + "点血");
                    chance++;
                }
                #endregion

                #region//玩家阵亡的处理
                //遍历图片数组所有图片，将其他没有踩到的地雷显示出来，并提示玩家阵亡
                else
                {
                    pblood[3].Visible = false;
                    pcb[i, j].Visible = true;
                    for (int m = 0; m < 15; m++)
                    {
                        for (int n = 0; n < 15; n++)
                        {
                            if (pcb[m, n].Visible == true)
                                continue;
                            else if (QiPan[m, n] == 9)
                            {
                                btn[m, n].Visible = false;
                                pcb[m, n].Visible = true;
                            }
                            else
                                btn[m, n].Enabled = false;
                        }
                    }
                    System.Windows.Forms.DialogResult re;
                    re = MessageBox.Show("被炸翻了啊，是否重来", "悲剧", MessageBoxButtons.OKCancel);
                    if (re == DialogResult.Yes)
                    {
                        //
                        //
                        //
                    }
                }
                #endregion
            }
            #endregion

            //若玩家没踩雷，则隐藏按钮，显示图片
            else
            {
                btn[i, j].Visible = false;
                pcb[i, j].Visible = true;
            }

            //如果玩家踩到的是0，则调用递归方法进行处理
            if (QiPan[i, j] == 0)
                chuli(i, j);

            #region//获胜检查，
            //遍历所有的按钮，如果发现一个可见按钮，且其对应位置不是地雷，则表示没有获胜
            //反之，则显示获胜
            int q = 0;
            for (; q < 225; q++)
            {
                //发现不是地雷的位置没有被打开，则判定玩家没有获胜，直接跳出检查
                if (btn[q / 15, q % 15].Visible == true && QiPan[q / 15, q % 15] != 9)
                    break;
            }
            //如果没有经过break跳出循环，则q的值必然为225，也就意味着玩家已经获得胜利
            if (q == 225)
            {
                for (int m = 0; m < 15; m++)
                {
                    for (int n = 0; n < 15; n++)
                    {
                        if (btn[m, n].Visible == true)
                        {
                            pcb[m, n].Image = Image.FromFile("胜利.jpg");
                            btn[m, n].Visible = false;
                            pcb[m, n].Visible = true;
                        }
                    }
                }
                System.Windows.Forms.DialogResult re;
                re = MessageBox.Show("智商不错，是否再来一盘", "恭喜", MessageBoxButtons.OKCancel);
                #region//！！！！此处待完善，需要查询删除所有控件的代码
                if (re == DialogResult.Yes)
                {
                    //
                    //
                    //
                }
                #endregion
                else
                    this.Close();
            }
            #endregion
        }
        #endregion

        #region//用于生成不重复的随机数，并存入DiLei数组
        //基本原理，将所有允许获取的数字放入一个num集合，循环随即获取集合下标，
        //将对应下标的数字存入DiLei数组，然后删除num集合中这个数字
        //下一次循环下标的范围减1
        private static void ran()
        {
            List<int> num = new List<int>();
            Random temp = new Random();
            for (int i = 0; i < QiPan.Length; i++)
            {
                num.Add(i);
            }
            for (int i = 0; i < DiLei.Length; i++)
            {
                int j = temp.Next(0, 225 - i);
                DiLei[i] = num[j];
                num.Remove(num[j]);
            }
        }
        #endregion

        #region//该递归方法用于处理当玩家点击到0的情况
        private void chuli(int a, int b)
        {
            //前面2层for循环用于锁定被点击的0附近（包括自己）9个格
            for (int i = a - 1; i < a + 2; i++)
            {
                for (int j = b - 1; j < b + 2; j++)
                {
                    //由于被点击的位置之前以作处理，这里就跳过该点
                    if (i == a && j == b)
                        continue;
                    else
                    {
                        //当i和j任意一个去-1或者15时，表示检测范围越界，无需对此进行检测
                        if (i == -1 || i == 15 || j == -1 || j == 15)
                            continue;
                        //当被检测位置的按钮是不可见时，表示该位置无需检测（可能是过去玩家点击的位置，也可能是此递归方法曾经检测过的位置）
                        else if (btn[i, j].Visible == false)
                            continue;
                        //当被检测位置不是0时，将这个位置的按钮隐藏，然后显示出这个位置的图片
                        else if (QiPan[i, j] != 0)
                        {
                            btn[i, j].Visible = false;
                            pcb[i, j].Visible = true;
                        }
                        //最后，被检测位置是0，而且之前没有被检测过，没有被玩家点击过，
                        //那么我们先将按钮隐藏，显示出图片，然后将这个点的横纵坐标作为参数，继续调用chuli方法
                        else
                        {
                            btn[i, j].Visible = false;
                            pcb[i, j].Visible = true;
                            chuli(i, j);
                        }
                    }
                }
            }

        }
        #endregion
    }

}
